public class DemoGCD {
   public static int getGreatestCommonDivisor(int x, int y) {
      int d = x < y ? x : y;
      int c = 1;
      while ( (x % d != 0) || (y % d != 0) ) {
         d = d - 1;
         c++;
      }
      System.err.println("GCD       no. of loops: " + c);
      return d;
   } 

   public static int getGreatestCommonDivisorLoops(int x, int y) {
      int c = 0;
      while (x != y) {
         while (x > y) {
            x = x - y;
            c++;
         }
         while (y > x) {
            y = y - x;
            c++;
         }
      }
      System.err.println("GCDLoops  no. of loops: " + c);
      return x;
   }

   public static int getGreatestCommonDivisorEuclid(int x, int y) {
      int c = 0;
      int remainder = x % y;
      while (remainder != 0) {
         x = y;
         y = remainder;
         remainder = x % y;
         c++;
      }
      System.err.println("GCDEuclid no. of loops: " + c);
      return y;
   }


   public static void main(String[] args) {
      int x = 600;
      int y = 1235;
      System.out.println("Greatest Common Divisor x: " + x + " y: " + y);
      int d1 = DemoGCD.getGreatestCommonDivisor(x, y);
      int d2 = DemoGCD.getGreatestCommonDivisorLoops(x, y);
      int d3 = DemoGCD.getGreatestCommonDivisorEuclid(x, y);

      System.out.println("\nResults");
      System.out.println("GCD:        " + d1);
      System.out.println("GCD Loops:  " + d2);
      System.out.println("GCD Euclid: " + d3);
   }
}
